#include <cstdio>
#include <string>

using std::FILE;
using std::string;

#include "autoptr"
struct BufferData: public ptrable
{
    char *data;
    size_t size;
public:
    BufferData(): ptrable(), data(),size() { }
    ~BufferData();
    /*
    static void* operator new(size_t size);
    static void operator delete(void *obj, size_t size);
    */
};
class BufferType
{
    autoptr<BufferData> data;
public:
    BufferType(size_t size);
    BufferType(size_t size, char c);
    
    BufferType(const char*b,          const char*e);
    BufferType(const unsigned char*b, const unsigned char*e);
    
    inline char& operator[] (size_t ind) { return data->data[ind]; }
    inline const char& operator[] (size_t ind) const { return data->data[ind]; }
    inline size_t size() const { return data->size; }
};

extern void AddWriteTask(FILE *fp, const BufferType& data);
extern void UpdateBuffers();
extern void FlushBuffers();

extern const string GetBufferStatus();

/* return true if the time was elapsed properly */
extern bool BufferElapse(double nseconds);

struct WaitInputRes
{
    bool input_pending;
    bool output_error;

    operator bool() { return input_pending; }
};
extern WaitInputRes BufferWaitInput(bool input_eof);

/* This is to be defined in main module */
extern void BufferEmptied(FILE *fp);

extern unsigned long long MaxBufferSize;
