#include <cstdio>
#include <sys/resource.h> /* PRIO_* */
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#define PRIORITY 6/*-20*/

#include "buffer.hh"

void BufferEmptied(FILE *fp)
{
    fp=fp;
    // don't care
}

void BufferProgMain(double bufsize)
//int main(int argc, char** argv)
{
    setpriority(PRIO_PROCESS, 0, PRIORITY);
    nice(PRIORITY);

    //if(argc == 2)
        MaxBufferSize = bufsize;//strtold(argv[1], 0);

    for(;;)
    {
        auto r = BufferWaitInput(false);
        if(r.output_error)
        {
            fprintf(stderr, "bufferprog: output closed\n");
            return;
        }
        if(r.input_pending)
        {
            static char Buf[131072];
            int res = read(STDIN_FILENO, Buf, sizeof Buf);
            if(res < 0 && (errno == EINTR || errno == EAGAIN))
                continue;
            if(res <= 0) break;

            BufferType buf(Buf, Buf+res);

            AddWriteTask(stdout, buf);
        }
    }

    BufferWaitInput(true);

    return;
}
